package com.bizmatics.mhfire.service.listener;

import com.bizmatics.mhfire.service.api.mhWater.OneCardApi;
import com.bizmatics.mhfire.service.config.mqtt.MqttInConfig;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Bean;
import org.springframework.integration.annotation.ServiceActivator;
import org.springframework.messaging.MessageHandler;
import org.springframework.stereotype.Component;

/**
 * @author yq
 * @date 2021/11/3 8:13
 */
@Slf4j
@Component
public class MqttListener {
    @Autowired
    private OneCardApi oneCardApi;

    public static final String MESSAGE_NAME = "messageInput";

    /**
     * 处理消息-消费者
     * @return
     */
    @Bean(MESSAGE_NAME)
    @ServiceActivator(inputChannel = MqttInConfig.CHANNEL_NAME_INPUT)
    public MessageHandler handler() {
        return message -> {
            log.info("mqtt-----接受到的消息"+message);
            String payload = message.getPayload().toString();
            //进行接口推送
            Object mqttReceivedTopic = message.getHeaders().get("mqtt_receivedTopic");
            if (null != mqttReceivedTopic){
                String topic = mqttReceivedTopic.toString();
                if (topic.equals("mh/water/info")){
                    oneCardApi.callInfoApi(payload);
                }else if (topic.equals("mh/water/alert")){
                    oneCardApi.callAlarmApi(payload);
                }
            }
        };
    }
}
